ConRO.DeathKnight = {};
ConRO.DeathKnight.CheckTalents = function()
end
ConRO.DeathKnight.CheckPvPTalents = function()
end
local ConRO_DeathKnight, ids = ...;

function ConRO:EnableRotationModule(mode)
	local _Player_Level = UnitLevel("player");

	mode = mode or 1;
	self.ModuleOnEnable = ConRO.DeathKnight.CheckTalents;
	self.ModuleOnEnable = ConRO.DeathKnight.CheckPvPTalents;	
	if _Player_Level <= 9 then
		self.Description = "DeathKnight [No Specialization Under 10]";
		self.ToggleHealer();
	end;
	if mode == 1 then
		self.Description = 'DeathKnight [Blood - Tank]';
		self.NextSpell = ConRO.DeathKnight.Blood;
		self.ToggleHealer();
	end;
	if mode == 2 then
		self.Description = 'DeathKnight [Frost - Melee]';
		self.NextSpell = ConRO.DeathKnight.Frost;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = 'DeathKnight	[Unholy - Melee]';
		self.NextSpell = ConRO.DeathKnight.Unholy;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;	
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.DeathKnight.CheckTalents;
	self.ModuleOnEnable = ConRO.DeathKnight.CheckPvPTalents;
	if mode == 1 then
		self.NextDef = ConRO.DeathKnight.BloodDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.DeathKnight.FrostDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.DeathKnight.UnholyDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.DeathKnight.Blood(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info		
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local _BloodBoil_RDY																= ConRO:AbilityReady(ids.Blood_Ability.BloodBoil, timeShift);
		local _BloodBoil_CHARGES															= ConRO:SpellCharges(ids.Blood_Ability.BloodBoil);
		local _BloodPlague_DEBUFF			 												= ConRO:TargetAura(ids.Blood_Debuff.BloodPlague, timeShift);
		local _CrimsonScourge_BUFF			 												= ConRO:Aura(ids.Blood_Buff.CrimsonScourge, timeShift);
		local _Hemostasis_BUFF, _Hemostasis_COUNT			 								= ConRO:Aura(ids.Blood_Buff.Hemostasis, timeShift);
	local _DancingRuneWeapon_RDY														= ConRO:AbilityReady(ids.Blood_Ability.DancingRuneWeapon, timeShift);
		local _DancingRuneWeapon_BUFF														= ConRO:Aura(ids.Blood_Buff.DancingRuneWeapon, timeShift);
	local _DarkCommand_RDY																= ConRO:AbilityReady(ids.Blood_Ability.DarkCommand, timeShift);
	local _DeathandDecay_RDY			 												= ConRO:AbilityReady(ids.Blood_Ability.DeathandDecay, timeShift);
		local _DeathandDecay_BUFF, _, _DeathandDecay_DUR									= ConRO:Aura(ids.Blood_Buff.DeathandDecay, timeShift);	
	local _DeathStrike_RDY					 											= ConRO:AbilityReady(ids.Blood_Ability.DeathStrike, timeShift);
		local _BloodShield_BUFF																= ConRO:Aura(ids.Blood_Buff.BloodShield, timeShift + 2);
	local _DeathsCaress_RDY				 												= ConRO:AbilityReady(ids.Blood_Ability.DeathsCaress, timeShift);
	local _HeartStrike_RDY 																= ConRO:AbilityReady(ids.Blood_Ability.HeartStrike, timeShift);
	local _MindFreeze_RDY					 											= ConRO:AbilityReady(ids.Blood_Ability.MindFreeze, timeShift);
	local _Marrowrend_RDY				 												= ConRO:AbilityReady(ids.Blood_Ability.Marrowrend, timeShift);
		local _BoneShield_BUFF, _BoneShield_COUNT			 								= ConRO:Aura(ids.Blood_Buff.BoneShield, timeShift + 3);

	local _BloodTap_RDY																	= ConRO:AbilityReady(ids.Blood_Talent.BloodTap, timeShift);
		local _BloodTap_CHARGES, _BloodTap_MAX_CHARGES										= ConRO:SpellCharges(ids.Blood_Talent.BloodTap);
	local _Blooddrinker_RDY																= ConRO:AbilityReady(ids.Blood_Talent.Blooddrinker, timeShift);
	local _Bonestorm_RDY					 											= ConRO:AbilityReady(ids.Blood_Talent.Bonestorm, timeShift);
	local _Consumption_RDY					 											= ConRO:AbilityReady(ids.Blood_Talent.Consumption, timeShift);
	local _MarkofBlood_RDY					 											= ConRO:AbilityReady(ids.Blood_Talent.MarkofBlood, timeShift);
	local _Tombstone_RDY					 											= ConRO:AbilityReady(ids.Blood_Talent.Tombstone, timeShift);
	
	local _BloodforBlood_RDY				 											= ConRO:AbilityReady(ids.Blood_PvPTalent.BloodforBlood, timeShift);
		local _BloodforBlood_BUFF							 								= ConRO:Aura(ids.Blood_Buff.BloodforBlood, timeShift);

	local _AbominationLimb_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.AbominationLimb, timeShift);
	local _DeathsDue_CD																	= ConRO:Cooldown(ids.Covenant_Ability.DeathsDue, timeShift);
	local _ShackletheUnworthy_RDY														= ConRO:AbilityReady(ids.Covenant_Ability.ShackletheUnworthy, timeShift);
		local _ShackletheUnworthy_DEBUFF			 										= ConRO:TargetAura(ids.Blood_Debuff.ShackletheUnworthy, timeShift);
	local _SwarmingMist_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.SwarmingMist, timeShift);
	
--Conditions	
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");

	local _BoneShield_Threshold = 7;
		if _DancingRuneWeapon_BUFF then
			_BoneShield_Threshold = 4;
		end

	local _Use_DeathandDecay = ids.Blood_Ability.DeathandDecay;
		if C_Covenants.GetActiveCovenantID() == 3 then
			_DeathandDecay_RDY = _DeathandDecay_RDY and _DeathsDue_CD <= 0;
			_Use_DeathandDecay = ids.Covenant_Ability.DeathsDue;
		end
		
--Indicators
	ConRO:AbilityInterrupt(ids.Blood_Ability.MindFreeze, _MindFreeze_RDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	
	ConRO:AbilityTaunt(ids.Blood_Ability.DarkCommand, _DarkCommand_RDY and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));
	
--Rotations	
	if not _in_combat then
		if _Blooddrinker_RDY then
			return ids.Blood_Talent.Blooddrinker;
		end
		
		if _DeathsCaress_RDY and not _BloodPlague_DEBUFF and not _target_in_melee then
			return ids.Blood_Ability.DeathsCaress;
		end
	end

	if currentSpell == ids.Blood_Talent.Blooddrinker then
		return ids.Blood_Talent.Blooddrinker;
	end
		
	if _Marrowrend_RDY and not _BoneShield_BUFF then
		return ids.Blood_Ability.Marrowrend;
	end
	
	if _Bonestorm_RDY and _RunicPower >= 100 and _enemies_in_melee >= 3 then
		return ids.Blood_Talent.Bonestorm;
	end

	if _HeartStrike_RDY and IsPlayerSpell(ids.Covenant_Ability.DeathsDue) and _DeathandDecay_DUR <= 1.5 then
		return ids.Blood_Ability.HeartStrike;
	end
	
	if _DeathStrike_RDY and (not _BloodShield_BUFF or _RunicPower == _RunicPower_Max or _Hemostasis_COUNT == 5) and _Player_Percent_Health <= 75 then
		return ids.Blood_Ability.DeathStrike;
	end

	if _BloodTap_RDY and (_Runes < 3 or _BloodTap_CHARGES == _BloodTap_MAX_CHARGES) then
		return ids.Blood_Talent.BloodTap;
	end

	if _BloodBoil_RDY and _BloodBoil_CHARGES == 2 then
		return ids.Blood_Ability.BloodBoil;
	end

	if _SwarmingMist_RDY then
		return ids.Covenant_Ability.SwarmingMist;
	end

	if _DeathandDecay_RDY and _CrimsonScourge_BUFF and tChosen[ids.Blood_Talent.RelishinBlood] then
		return _Use_DeathandDecay;
	end

	if _ShackletheUnworthy_RDY then
		return ids.Covenant_Ability.ShackletheUnworthy;
	end

	if _AbominationLimb_RDY then
		return ids.Covenant_Ability.AbominationLimb;
	end

	if _Blooddrinker_RDY and not _DancingRuneWeapon_BUFF then
		return ids.Blood_Talent.Blooddrinker;
	end
	
	if _BloodBoil_RDY and not _BloodPlague_DEBUFF then
		return ids.Blood_Ability.BloodBoil;
	end	
	
	if _Marrowrend_RDY and _BoneShield_COUNT <= _BoneShield_Threshold then
		return ids.Blood_Ability.Marrowrend;
	end	

	if _DeathandDecay_RDY and _Runes >= 3 and _enemies_in_melee >= 3 then
		return _Use_DeathandDecay;
	end	

	if _BloodforBlood_RDY and _Runes >= 3 and _BoneShield_COUNT >= 5 and not _BloodforBlood_BUFF and _Player_Percent_Health >= 65 then
		return ids.Blood_PvPTalent.BloodforBlood;
	end	

	if _HeartStrike_RDY and _Runes >= 3 and _BoneShield_COUNT >= 5 then
		return ids.Blood_Ability.HeartStrike;
	end	

	if _BloodBoil_RDY and _DancingRuneWeapon_BUFF then
		return ids.Blood_Ability.BloodBoil;
	end	

	if _DeathandDecay_RDY and _CrimsonScourge_BUFF then
		return _Use_DeathandDecay;
	end	

	if _Consumption_RDY then
		return ids.Blood_Talent.Consumption;
	end
	
	if _BloodBoil_RDY then
		return ids.Blood_Ability.BloodBoil;
	end
	
return nil;
end

function ConRO.DeathKnight.BloodDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info		
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Abilities
	local _DancingRuneWeapon_RDY		 												= ConRO:AbilityReady(ids.Blood_Ability.DancingRuneWeapon, timeShift);
	local _DeathStrike_RDY					 											= ConRO:AbilityReady(ids.Blood_Ability.DeathStrike, timeShift);
	local _IceboundFortitude_RDY		 												= ConRO:AbilityReady(ids.Blood_Ability.IceboundFortitude, timeShift);
	local _Lichborne_RDY																= ConRO:AbilityReady(ids.Blood_Ability.Lichborne, timeShift);
	local _RaiseDead_RDY, _RaiseDead_CD													= ConRO:AbilityReady(ids.Frost_Ability.RaiseDead, timeShift);
	local _SacrificialPact_RDY															= ConRO:AbilityReady(ids.Blood_Ability.SacrificialPact, timeShift);
	local _VampiricBlood_RDY			 												= ConRO:AbilityReady(ids.Blood_Ability.VampiricBlood, timeShift);
	
	local _Blooddrinker_RDY 															= ConRO:AbilityReady(ids.Blood_Talent.Blooddrinker, timeShift);
	local _DeathPact_RDY 																= ConRO:AbilityReady(ids.Blood_Talent.DeathPact, timeShift);

	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");

--Rotations	
	if _Blooddrinker_RDY and _Player_Percent_Health <= 75 then
		return ids.Blood_Talent.Blooddrinker;
	end

	if _VampiricBlood_RDY and _Player_Percent_Health <= 50 then
		return ids.Blood_Ability.VampiricBlood;
	end
	
	if _DeathPact_RDY and _Player_Percent_Health <= 50 then
		return ids.Blood_Talent.DeathPact;
	end

	if _LichborneRDY and _Player_Percent_Health <= 40 then
		return ids.Blood_Ability.Lichborne;
	end

	if _SacrificialPact_RDY and _Player_Percent_Health <= 20 and _RaiseDead_CD > 60 then
		return ids.Unholy_Ability.SacrificialPact;
	end
	
	if _DeathStrike_RDY and _Player_Percent_Health <= 30 then
		return ids.Blood_Ability.DeathStrike;
	end
	
	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _DancingRuneWeapon_RDY then
		return ids.Blood_Ability.DancingRuneWeapon;
	end
	
	if _IceboundFortitude_RDY then
		return ids.Blood_Ability.IceboundFortitude;
	end
	
	return nil;
end

function ConRO.DeathKnight.Frost(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities	
	local _ChainsofIce_RDY																= ConRO:AbilityReady(ids.Frost_Ability.ChainsofIce, timeShift);
		local _ColdHeart_BUFF, _ColdHeart_COUNT												= ConRO:Form(ids.Frost_Buff.ColdHeart);	
	local _DeathandDecay_RDY					 										= ConRO:AbilityReady(ids.Frost_Ability.DeathandDecay, timeShift);
		local _DeathandDecay_BUFF					 										= ConRO:Aura(ids.Frost_Buff.DeathandDecay, timeShift);		
	local _DeathStrike_RDY					 											= ConRO:AbilityReady(ids.Frost_Ability.DeathStrike, timeShift);
		local _DarkSuccor_BUFF					 											= ConRO:Aura(ids.Frost_Buff.DarkSuccor, timeShift);
	local _EmpowerRuneWeapon_RDY		 												= ConRO:AbilityReady(ids.Frost_Ability.EmpowerRuneWeapon, timeShift);
		local _EmpowerRuneWeapon_BUFF														= ConRO:Aura(ids.Frost_Buff.EmpowerRuneWeapon, timeShift);
		local _UnholyStrength_BUFF, _, _UnholyStrength_DUR									= ConRO:Aura(ids.Frost_Buff.UnholyStrength, timeShift);
		local _RazorIce_DEBUFF, _RazorIce_COUNT				 								= ConRO:TargetAura(ids.Frost_Debuff.RazorIce, timeShift);		
	local _FrostStrike_RDY				 												= ConRO:AbilityReady(ids.Frost_Ability.FrostStrike, timeShift);
		local _IcyTalons_BUFF, _, _IcyTalons_DUR											= ConRO:Aura(ids.Frost_Buff.IcyTalons, timeShift + 1.5);
	local _FrostwyrmsFury_RDY															= ConRO:AbilityReady(ids.Frost_Ability.FrostwyrmsFury, timeShift);
	local _HowlingBlast_RDY					 											= ConRO:AbilityReady(ids.Frost_Ability.HowlingBlast, timeShift);
		local _FrostFever_DEBUFF															= ConRO:TargetAura(ids.Frost_Debuff.FrostFever, timeShift);	
		local _Rime_BUFF																	= ConRO:Aura(ids.Frost_Buff.Rime, timeShift);
	local _MindFreeze_RDY					 											= ConRO:AbilityReady(ids.Frost_Ability.MindFreeze, timeShift);
	local _Obliterate_RDY					 											= ConRO:AbilityReady(ids.Frost_Ability.Obliterate, timeShift);
		local _KillingMachine_BUFF															= ConRO:Aura(ids.Frost_Buff.KillingMachine, timeShift);
	local _PillarofFrost_RDY, _PillarofFrost_CD											= ConRO:AbilityReady(ids.Frost_Ability.PillarofFrost, timeShift);
		local _PillarofFrost_BUFF, _, _PillarofFrost_DUR									= ConRO:Aura(ids.Frost_Buff.PillarofFrost, timeShift);
	local _RaiseDead_RDY																= ConRO:AbilityReady(ids.Frost_Ability.RaiseDead, timeShift);	
	local _RemorselessWinter_RDY, _RemorselessWinter_CD									= ConRO:AbilityReady(ids.Frost_Ability.RemorselessWinter, timeShift);

	local _BreathofSindragosa_RDY, _BreathofSindragosa_CD								= ConRO:AbilityReady(ids.Frost_Talent.BreathofSindragosa, timeShift);
		local _BreathofSindragosa_BUFF														= ConRO:Form(ids.Frost_Form.BreathofSindragosa);
	local _Frostscythe_RDY 																= ConRO:AbilityReady(ids.Frost_Talent.Frostscythe, timeShift);
	local _GlacialAdvance_RDY			 												= ConRO:AbilityReady(ids.Frost_Talent.GlacialAdvance, timeShift);
	local _HornofWinter_RDY																= ConRO:AbilityReady(ids.Frost_Talent.HornofWinter, timeShift);
	local _HypothermicPresence_RDY														= ConRO:AbilityReady(ids.Frost_Talent.HypothermicPresence, timeShift);
		
	local _ChillStreak_RDY					 											= ConRO:AbilityReady(ids.Frost_PvPTalent.ChillStreak, timeShift);

	local _AbominationLimb_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.AbominationLimb, timeShift);
	local _DeathsDue_CD																	= ConRO:Cooldown(ids.Covenant_Ability.DeathsDue, timeShift);
	local _ShackletheUnworthy_RDY														= ConRO:AbilityReady(ids.Covenant_Ability.ShackletheUnworthy, timeShift);
		local _ShackletheUnworthy_DEBUFF			 										= ConRO:TargetAura(ids.Blood_Debuff.ShackletheUnworthy, timeShift);
	local _SwarmingMist_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.SwarmingMist, timeShift);

	local _Use_DeathandDecay = ids.Frost_Ability.DeathandDecay;
		if C_Covenants.GetActiveCovenantID() == 3 then
			_DeathandDecay_RDY = _DeathandDecay_RDY and _DeathsDue_CD <= 0;
			_Use_DeathandDecay = ids.Covenant_Ability.DeathsDue;
		end
		
--Conditions
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	
--Indicators	
	ConRO:AbilityInterrupt(ids.Frost_Ability.MindFreeze, _MindFreeze_RDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	
	ConRO:AbilityBurst(ids.Frost_Ability.FrostwyrmsFury, _FrostwyrmsFury_RDY and _in_combat and _PillarofFrost_BUFF and _PillarofFrost_DUR <= 5);
	ConRO:AbilityBurst(ids.Frost_Talent.BreathofSindragosa, _BreathofSindragosa_RDY and _Runes >= 3 and _RunicPower >= 60 and _PillarofFrost_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Frost_Ability.EmpowerRuneWeapon, _EmpowerRuneWeapon_RDY and _Runes >= 3 and _RunicPower >= 60 and _PillarofFrost_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.AbominationLimb, _AbominationLimb_RDY and _FrostFever_DEBUFF and ConRO_BurstButton:IsVisible());

--Rotations
	if tChosen[ids.Frost_Talent.ColdHeart] then
		if tChosen[ids.Frost_Talent.Obliteration] then
			if _ChainsofIce_RDY and not _PillarofFrost_BUFF and (_ColdHeart_COUNT >= 20 or (_UnholyStrength_BUFF and _UnholyStrength_DUR <= 2 and _ColdHeart_COUNT >= 17)) then
				return ids.Frost_Ability.ChainsofIce;
			end		
		elseif tChosen[ids.Frost_Talent.BreathofSindragosa] then
			if _ChainsofIce_RDY and ((_ColdHeart_COUNT >= 20 and _PillarofFrost_BUFF and _PillarofFrost_DUR <= 3) or (_ColdHeart_COUNT >= 10 and not _PillarofFrost_BUFF and _PillarofFrost_CD >= 28)) then
				return ids.Frost_Ability.ChainsofIce;
			end		
		else
			if _ChainsofIce_RDY and _ColdHeart_COUNT >= 20 and _PillarofFrost_BUFF and _PillarofFrost_DUR <= 3 then
				return ids.Frost_Ability.ChainsofIce;
			end
		end
	end
	
	if _ChillStreak_RDY and _PillarofFrost_DUR <= 11 then
		return ids.Frost_PvPTalent.ChillStreak;
	end
	
	if tChosen[ids.Frost_Talent.BreathofSindragosa] and _BreathofSindragosa_BUFF then
		if _PillarofFrost_RDY then
			return ids.Frost_Ability.PillarofFrost;
		end

		if _HypothermicPresence_RDY and not _EmpowerRuneWeapon_BUFF then
			return ids.Frost_Talent.HypothermicPresence;
		end
		
		if _Obliterate_RDY and _RunicPower <= 30 then
			return ids.Frost_Ability.Obliterate;
		end

		if _SwarmingMist_RDY and _RunicPower <= 30 then
			return ids.Covenant_Ability.SwarmingMist;
		end
	
		if _RemorselessWinter_RDY and tChosen[ids.Frost_Talent.GatheringStorm] then
			return ids.Frost_Ability.RemorselessWinter;
		end
		
		if _HowlingBlast_RDY and (not _FrostFever_DEBUFF or _Rime_BUFF) then
			return ids.Frost_Ability.HowlingBlast;
		end
		
		if _Obliterate_RDY and (_Runes <= 5 or _RunicPower <= 45) then
			return ids.Frost_Ability.Obliterate;
		end
		
		if _RemorselessWinter_RDY then
			return ids.Frost_Ability.RemorselessWinter;
		end
		
		if tChosen[ids.Frost_Talent.Frostscythe] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			if _Frostscythe_RDY and _RunicPower <= 73 then
				return ids.Frost_Talent.Frostscythe;
			end		
		else
			if _Obliterate_RDY and _RunicPower <= 73 then
				return ids.Frost_Ability.Obliterate;
			end
		end
		
		if _HornofWinter_RDY and _Runes <= 4 and _RunicPower <= _RunicPower_Max - 25 then
			return ids.Frost_Talent.HornofWinter;
		end
		
		if _ShackletheUnworthy_RDY then
			return ids.Covenant_Ability.ShackletheUnworthy;
		end
		
		if _AbominationLimb_RDY then
			return ids.Covenant_Ability.AbominationLimb;
		end
		
		return nil;	
		
	elseif tChosen[ids.Frost_Talent.BreathofSindragosa] and (_BreathofSindragosa_RDY or _BreathofSindragosa_CD <= 10) and ConRO_FullButton:IsVisible() then
		if _RaiseDead_RDY and _Runes >= 3 and _RunicPower >= 60 and _PillarofFrost_RDY then
			return ids.Frost_Ability.RaiseDead;
		end
		
		if _EmpowerRuneWeapon_RDY and _Runes >= 3 and _RunicPower >= 60 and _PillarofFrost_RDY then
			return ids.Frost_Ability.EmpowerRuneWeapon;
		end
		
		if _BreathofSindragosa_RDY and _Runes >= 3 and _RunicPower >= 60 and _PillarofFrost_RDY then
			return ids.Frost_Talent.BreathofSindragosa;
		end
		
		if _HowlingBlast_RDY and _Rime_BUFF then
			return ids.Frost_Ability.HowlingBlast;
		end	
		
		if _DeathandDecay_RDY and not _DeathandDecay_BUFF and (((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) or _Use_DeathandDecay == ids.Covenant_Ability.DeathsDue) then
			return _Use_DeathandDecay;
		end
		
		if _ShackletheUnworthy_RDY then
			return ids.Covenant_Ability.ShackletheUnworthy;
		end
		
		if tChosen[ids.Frost_Talent.Frostscythe] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			if _Frostscythe_RDY and (_Runes >= 5 or _RunicPower <= 59) then
				return ids.Frost_Talent.Frostscythe;
			end
		else
			if _Obliterate_RDY and (_Runes >= 6 or _RunicPower <= 59) then
				return ids.Frost_Ability.Obliterate;
			end
		end
		
	elseif tChosen[ids.Frost_Talent.Obliteration] and _PillarofFrost_BUFF then
		if _DeathandDecay_RDY and not _DeathandDecay_BUFF and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return _Use_DeathandDecay;
		end
		
		if tChosen[ids.Frost_Talent.Frostscythe] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			if _Frostscythe_RDY and _KillingMachine_BUFF then
				return ids.Frost_Talent.Frostscythe;
			end
		else
			if _Obliterate_RDY and _KillingMachine_BUFF then
				return ids.Frost_Ability.Obliterate;
			end	
		end

		if _SwarmingMist_RDY and _RunicPower <= 30 then
			return ids.Covenant_Ability.SwarmingMist;
		end
		
		if _HornofWinter_RDY and _Runes <= 3 then
			return ids.Frost_Talent.HornofWinter;
		end
		
		if _GlacialAdvance_RDY and (not _KillingMachine_BUFF or _RunicPower >= 73) and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return ids.Frost_Talent.GlacialAdvance;
		end	
		
		if _FrostStrike_RDY and (not _KillingMachine_BUFF or _RunicPower >= 73) then
			return ids.Frost_Ability.FrostStrike;
		end

		if _HowlingBlast_RDY and _Rime_BUFF then
			return ids.Frost_Ability.HowlingBlast;
		end
		
		if tChosen[ids.Frost_Talent.Frostscythe] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			if _Frostscythe_RDY then
				return ids.Frost_Talent.Frostscythe;
			end
		else
			if _Obliterate_RDY then
				return ids.Frost_Ability.Obliterate;
			end
		end

		if _ShackletheUnworthy_RDY then
			return ids.Covenant_Ability.ShackletheUnworthy;
		end

		if _AbominationLimb_RDY then
			return ids.Covenant_Ability.AbominationLimb;
		end
		
		return nil;
	else
		if tChosen[ids.Frost_Talent.IcyTalons] and not _IcyTalons_BUFF then
			if _RunicPower < 30 and tChosen[ids.Frost_Talent.GlacialAdvance] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
				if _GlacialAdvance_RDY then
					return ids.Frost_Talent.GlacialAdvance;
				end
			else
				if _FrostStrike_RDY then
					return ids.Frost_Ability.FrostStrike;
				end
			end
		end
		
		if _RaiseDead_RDY and _PillarofFrost_RDY and not tChosen[ids.Frost_Talent.BreathofSindragosa] then
			return ids.Frost_Ability.RaiseDead;
		end
		
		if _EmpowerRuneWeapon_RDY and _PillarofFrost_RDY and not tChosen[ids.Frost_Talent.BreathofSindragosa] and ConRO_FullButton:IsVisible() then
			return ids.Frost_Ability.EmpowerRuneWeapon;
		end
		
		if _HypothermicPresence_RDY and not _EmpowerRuneWeapon_BUFF and (not tChosen[ids.Frost_Talent.BreathofSindragosa] or (tChosen[ids.Frost_Talent.BreathofSindragosa] and _BreathofSindragosa_CD >= 40)) then
			return ids.Frost_Talent.HypothermicPresence;
		end

		if _SwarmingMist_RDY and (not tChosen[ids.Frost_Talent.BreathofSindragosa] or (tChosen[ids.Frost_Talent.BreathofSindragosa] and _BreathofSindragosa_CD >= 55))  then
			return ids.Covenant_Ability.SwarmingMist;
		end
		
		if _RemorselessWinter_RDY and tChosen[ids.Frost_Talent.GatheringStorm] and (_PillarofFrost_RDY or _PillarofFrost_CD >= 20) then
			return ids.Frost_Ability.RemorselessWinter;
		end
		
		if _PillarofFrost_RDY and (tChosen[ids.Frost_Talent.Icecap] or (tChosen[ids.Frost_Talent.Obliteration] and _Runes <= 2 and _RunicPower <= 25) or (tChosen[ids.Frost_Talent.BreathofSindragosa] and _BreathofSindragosa_CD >= 40)) then
			return ids.Frost_Ability.PillarofFrost;
		end
		
		if _HowlingBlast_RDY and (not _FrostFever_DEBUFF or _Rime_BUFF) then
			return ids.Frost_Ability.HowlingBlast;
		end

		if _Obliterate_RDY and _Runes >= 3 and tChosen[ids.Frost_Talent.FrozenPulse] then
			return ids.Frost_Ability.Obliterate;
		end
		
		if _ShackletheUnworthy_RDY and not (tChosen[ids.Frost_Talent.BreathofSindragosa] or tChosen[ids.Frost_Talent.Obliteration]) then
			return ids.Covenant_Ability.ShackletheUnworthy;
		end

		if _AbominationLimb_RDY and not (tChosen[ids.Frost_Talent.BreathofSindragosa] or tChosen[ids.Frost_Talent.Obliteration]) and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.AbominationLimb;
		end
		
		if _FrostStrike_RDY and _RunicPower >= 73 and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee <= 1) or ConRO_SingleButton:IsVisible()) then
			return ids.Frost_Ability.FrostStrike;
		end	

		if _KillingMachine_BUFF then
			if _Frostscythe_RDY then
				return ids.Frost_Talent.Frostscythe;
			end
		else
			if _Obliterate_RDY and _Runes >= 4 and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee <= 1) or ConRO_SingleButton:IsVisible()) then
				return ids.Frost_Ability.Obliterate;
			end
		end

		if _RemorselessWinter_RDY and not tChosen[ids.Frost_Talent.GatheringStorm] and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return ids.Frost_Ability.RemorselessWinter;
		end	

		if _DeathandDecay_RDY and not _DeathandDecay_BUFF and (((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) or _Use_DeathandDecay == ids.Covenant_Ability.DeathsDue) then
			return _Use_DeathandDecay;
		end

		if _Frostscythe_RDY and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return ids.Frost_Talent.Frostscythe;
		end
		
		if _Obliterate_RDY then
			return ids.Frost_Ability.Obliterate;
		end
		
		if _GlacialAdvance_RDY and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return ids.Frost_Talent.GlacialAdvance;
		end	

		if _HornofWinter_RDY and _Runes <= 4 and _RunicPower <= _RunicPower_Max - 25 and not tChosen[ids.Frost_Talent.Obliteration] and (not tChosen[ids.Frost_Talent.BreathofSindragosa] or (tChosen[ids.Frost_Talent.BreathofSindragosa] and _BreathofSindragosa_CD >= 40)) then
			return ids.Frost_Talent.HornofWinter;
		end
		
		if _DeathStrike_RDY and _DarkSuccor_BUFF and _Player_Percent_Health <= 85 then
			return ids.Frost_Ability.DeathStrike;
		end		

		if _FrostStrike_RDY and not tChosen[ids.Frost_Talent.IcyTalons] then
			return ids.Frost_Ability.FrostStrike;
		end
		
		return nil;
	end
end

function ConRO.DeathKnight.FrostDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Abilities	
	local _DeathStrike_RDY																= ConRO:AbilityReady(ids.Frost_Ability.DeathStrike, timeShift);
		local _DarkSuccor_BUFF																= ConRO:Aura(ids.Frost_Buff.DarkSuccor, timeShift);
	local _IceboundFortitude_RDY														= ConRO:AbilityReady(ids.Frost_Ability.IceboundFortitude, timeShift);
	local _Lichborne_RDY																= ConRO:AbilityReady(ids.Frost_Ability.Lichborne, timeShift);
	local _RaiseDead_RDY, _RaiseDead_CD													= ConRO:AbilityReady(ids.Frost_Ability.RaiseDead, timeShift);	
	local _SacrificialPact_RDY															= ConRO:AbilityReady(ids.Frost_Ability.SacrificialPact, timeShift);
	
	local _DeathPact_RDY																= ConRO:AbilityReady(ids.Frost_Talent.DeathPact, timeShift);	
	
	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	
--Rotations	
	if _DeathPact_RDY and _Player_Percent_Health <= 50 then
		return ids.Frost_Talent.DeathPact;
	end
	
	if _Lichborne_RDY and _Player_Percent_Health <= 40 then
		return ids.Frost_Ability.Lichborne;
	end

	if _SacrificialPact_RDY and _Player_Percent_Health <= 20 and _RaiseDead_CD > 60 then
		return ids.Unholy_Ability.SacrificialPact;
	end
	
	if _DeathStrike_RDY and _DarkSuccor_BUFF or _Player_Percent_Health <= 30 then
		return ids.Frost_Ability.DeathStrike;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _IceboundFortitude_RDY then
		return ids.Frost_Ability.IceboundFortitude;
	end
	
	return nil;
end

function ConRO.DeathKnight.Unholy(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities	
	local _Apocalypse_RDY, _Apocalypse_CD, _Apocalypse_MaxCD							= ConRO:AbilityReady(ids.Unholy_Ability.Apocalypse, timeShift);
	local _ArmyoftheDead_RDY			 												= ConRO:AbilityReady(ids.Unholy_Ability.ArmyoftheDead, timeShift);
	local _DarkTransformation_RDY				 										= ConRO:AbilityReady(ids.Unholy_Ability.DarkTransformation, timeShift);
	local _DeathandDecay_RDY			 												= ConRO:AbilityReady(ids.Unholy_Ability.DeathandDecay, timeShift);
		local _DeathandDecay_BUFF															= ConRO:Aura(ids.Unholy_Buff.DeathandDecay, timeShift);	
	local _DeathCoil_RDY																= ConRO:AbilityReady(ids.Unholy_Ability.DeathCoil, timeShift);
		local _SuddenDoom_BUFF					 											= ConRO:Aura(ids.Unholy_Buff.SuddenDoom, timeShift);
	local _DeathStrike_RDY					 											= ConRO:AbilityReady(ids.Unholy_Ability.DeathStrike, timeShift);
		local _DarkSuccor_BUFF					 											= ConRO:Aura(ids.Unholy_Buff.DarkSuccor, timeShift);
	local _Epidemic_RDY						 											= ConRO:AbilityReady(ids.Unholy_Ability.Epidemic, timeShift);
	local _FesteringStrike_RDY				 											= ConRO:AbilityReady(ids.Unholy_Ability.FesteringStrike, timeShift);
		local _FesteringWound_DEBUFF, _FesteringWound_COUNT 								= ConRO:TargetAura(ids.Unholy_Debuff.FesteringWound, timeShift);
	local _MindFreeze_RDY																= ConRO:AbilityReady(ids.Unholy_Ability.MindFreeze, timeShift);
	local _Outbreak_RDY																	= ConRO:AbilityReady(ids.Unholy_Ability.Outbreak, timeShift);
		local _VirulentPlague_DEBUFF			 											= ConRO:TargetAura(ids.Unholy_Debuff.VirulentPlague, timeShift + 4);
	local _RaiseDead_RDY					 											= ConRO:AbilityReady(ids.Unholy_Ability.RaiseDead, timeShift);
	local _ScourgeStrike_RDY				 											= ConRO:AbilityReady(ids.Unholy_Ability.ScourgeStrike, timeShift);

	local _ClawingShadows_RDY															= ConRO:AbilityReady(ids.Unholy_Talent.ClawingShadows, timeShift);	
	local _Defile_RDY																	= ConRO:AbilityReady(ids.Unholy_Talent.Defile, timeShift);
	local _SoulReaper_RDY					 											= ConRO:AbilityReady(ids.Unholy_Talent.SoulReaper, timeShift);
	local _SummonGargoyle_RDY, _SummonGargoyle_CD										= ConRO:AbilityReady(ids.Unholy_Talent.SummonGargoyle, timeShift);
	local _UnholyAssault_RDY					 										= ConRO:AbilityReady(ids.Unholy_Talent.UnholyAssault, timeShift);
	local _UnholyBlight_RDY																= ConRO:AbilityReady(ids.Unholy_Talent.UnholyBlight, timeShift);
		local _UnholyBlight_DEBUFF															= ConRO:TargetAura(ids.Unholy_Debuff.UnholyBlight, timeShift);

	local _NecroticStrike_RDY															= ConRO:AbilityReady(ids.Unholy_PvPTalent.NecroticStrike, timeShift);
		local _NecroticStrike_DEBUFF, _, _NecroticStrike_DUR								= ConRO:TargetAura(ids.Unholy_Debuff.NecroticStrike, timeShift);
	local _RaiseAbomination_RDY															= ConRO:AbilityReady(ids.Unholy_PvPTalent.RaiseAbomination, timeShift);
	local _Transfusion_RDY					 											= ConRO:AbilityReady(ids.Unholy_PvPTalent.Transfusion, timeShift);
		local _Transfusion_BUFF						 										= ConRO:Aura(ids.Unholy_Buff.Transfusion, timeShift);

	local _AbominationLimb_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.AbominationLimb, timeShift);
	local _DeathsDue_CD																	= ConRO:Cooldown(ids.Covenant_Ability.DeathsDue, timeShift);
	local _ShackletheUnworthy_RDY														= ConRO:AbilityReady(ids.Covenant_Ability.ShackletheUnworthy, timeShift);
		local _ShackletheUnworthy_DEBUFF			 										= ConRO:TargetAura(ids.Blood_Debuff.ShackletheUnworthy, timeShift);
	local _SwarmingMist_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.SwarmingMist, timeShift);
	
--Conditions	
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	local _Target_Percent_Health  														= ConRO:PercentHealth('target');
	local _can_execute																	= _Target_Percent_Health <= 36;
	
	local _Pet_summoned 																= ConRO:CallPet();
	local _Pet_assist 																	= ConRO:PetAssist();
	local _Pet_Percent_Health															= ConRO:PercentHealth('pet');
	local _Ghoul_out																	= IsSpellKnown(ids.Unholy_PetAbility.Claw, true);
	
	local _Cast_ArmyoftheDead = ids.Unholy_Ability.ArmyoftheDead;
		if _is_PvP then
			if pvpChosen[ids.Unholy_PvPTalent.RaiseAbomination] then
				_ArmyoftheDead_RDY = _RaiseAbomination_RDY;
				_Cast_ArmyoftheDead = ids.Unholy_PvPTalent.RaiseAbomination;
			end	
		end

	local _Use_DeathandDecay = ids.Unholy_Ability.DeathandDecay;
		if C_Covenants.GetActiveCovenantID() == 3 then
			_DeathandDecay_RDY = _DeathandDecay_RDY and _DeathsDue_CD <= 0;
			_Use_DeathandDecay = ids.Covenant_Ability.DeathsDue;
		end
		
--Indicators	
	ConRO:AbilityInterrupt(ids.Unholy_Ability.MindFreeze, _MindFreeze_RDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	
	ConRO:AbilityBurst(_Cast_ArmyoftheDead, _in_combat and _ArmyoftheDead_RDY);
	ConRO:AbilityBurst(ids.Unholy_Ability.DarkTransformation, _in_combat and _DarkTransformation_RDY and _Ghoul_out and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Unholy_Ability.Apocalypse, _in_combat and _Apocalypse_RDY and _FesteringWound_COUNT >= 4 and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Unholy_Talent.UnholyAssault, _in_combat and _UnholyAssault_RDY and _FesteringWound_COUNT < 3 and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.AbominationLimb, _AbominationLimb_RDY and ConRO_BurstButton:IsVisible());
	
--Warnings
	if not _Pet_summoned and _RaiseDead_RDY then
		UIErrorsFrame:AddMessage("Call your pet!!!", 1.0, 0.0, 0.0, 53, 5);
		return ids.Unholy_Ability.RaiseDead;
	end

	if not  _Pet_assist and _Pet_summoned then
		UIErrorsFrame:AddMessage("Pet is NOT attacking!!!", 1.0, 0.0, 0.0, 53, 5);
	end

--Rotations
	if _SummonGargoyle_RDY and _RunicPower >= 90 and _SuddenDoom_BUFF then
		return ids.Unholy_Talent.SummonGargoyle;
	end

	if _DeathCoil_RDY and _SummonGargoyle_CD >= 150 and tChosen[ids.Unholy_Talent.SummonGargoyle] then
		return ids.Unholy_Ability.DeathCoil;
	end

	if _DeathStrike_RDY and _DarkSuccor_BUFF and _SummonGargoyle_CD >= 150 and tChosen[ids.Unholy_Talent.SummonGargoyle] then
		return ids.Unholy_Ability.DeathStrike;
	end
	
	if _UnholyBlight_RDY and not (_VirulentPlague_DEBUFF and _UnholyBlight_DEBUFF) then
		return ids.Unholy_Talent.UnholyBlight;
	end		

	if _Outbreak_RDY and not _VirulentPlague_DEBUFF then
		return ids.Unholy_Ability.Outbreak;
	end	
		
	if _SoulReaper_RDY and _Runes >= 1 and _can_execute then
		return ids.Unholy_Talent.SoulReaper;
	end

	if _DarkTransformation_RDY and _Ghoul_out and ConRO_FullButton:IsVisible() then
		return ids.Unholy_Ability.DarkTransformation;
	end	

	if _Apocalypse_RDY and _FesteringWound_COUNT >= 4 and ConRO_FullButton:IsVisible() then
		return ids.Unholy_Ability.Apocalypse;
	end

	if _UnholyAssault_RDY and _FesteringWound_COUNT < 3 and _Apocalypse_CD <= _Apocalypse_MaxCD - 3 and _Apocalypse_CD >= _Apocalypse_MaxCD - 15 and ConRO_FullButton:IsVisible() then
		return ids.Unholy_Talent.UnholyAssault;
	end	
		
	if (_RunicPower >= 80 or _SuddenDoom_BUFF) and not (tChosen[ids.Unholy_Talent.SummonGargoyle] and (_SummonGargoyle_RDY or _SummonGargoyle_CD <= 10)) then
		if ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			if _Epidemic_RDY  then
				return ids.Unholy_Ability.Epidemic;
			end
		else
			if _DeathCoil_RDY then
				return ids.Unholy_Ability.DeathCoil;
			end
		end
	end

	if _SwarmingMist_RDY then
		return ids.Covenant_Ability.SwarmingMist;
	end
		
	if _AbominationLimb_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.AbominationLimb;
	end
		
	if _ShackletheUnworthy_RDY then
		return ids.Covenant_Ability.ShackletheUnworthy;
	end
		
	if tChosen[ids.Unholy_Talent.Defile] then
		if _Defile_RDY then
			return ids.Unholy_Talent.Defile;
		end
	else
		if _DeathandDecay_RDY and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible() or tChosen[ids.Unholy_Talent.Pestilence]) then
			return _Use_DeathandDecay;
		end
	end

	if ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) and _DeathandDecay_BUFF then 
		if _ClawingShadows_RDY and tChosen[ids.Unholy_Talent.ClawingShadows] and ((_FesteringWound_COUNT >= 1 and (not _Apocalypse_RDY or _Apocalypse_CD > 5)) or (_FesteringWound_COUNT >= 5 and _Apocalypse_RDY)) then
			return ids.Unholy_Talent.ClawingShadows;
		elseif _ScourgeStrike_RDY and not tChosen[ids.Unholy_Talent.ClawingShadows] and ((_FesteringWound_COUNT >= 1 and (not _Apocalypse_RDY or _Apocalypse_CD > 5)) or (_FesteringWound_COUNT >= 5 and _Apocalypse_RDY)) then
			return ids.Unholy_Ability.ScourgeStrike;
		end
	end
		
	if _Epidemic_RDY and not (tChosen[ids.Unholy_Talent.SummonGargoyle] and (_SummonGargoyle_RDY or _SummonGargoyle_CD <= 10)) and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Unholy_Ability.Epidemic;
	end
		
	if _NecroticStrike_RDY and pvpChosen[ids.Unholy_PvPTalent.NecroticStrike] and _FesteringWound_COUNT >= 1 and (not _NecroticStrike_DEBUFF or (_NecroticStrike_DEBUFF and _NecroticStrike_DUR <= 4)) then
		return ids.Unholy_PvPTalent.NecroticStrike;
	end
		
	if _ClawingShadows_RDY and tChosen[ids.Unholy_Talent.ClawingShadows] and ((_FesteringWound_COUNT >= 1 and (not _Apocalypse_RDY or _Apocalypse_CD > 5)) or (_FesteringWound_COUNT >= 5 and _Apocalypse_RDY)) then
		return ids.Unholy_Talent.ClawingShadows;
	elseif _ScourgeStrike_RDY and not tChosen[ids.Unholy_Talent.ClawingShadows] and ((_FesteringWound_COUNT >= 1 and (not _Apocalypse_RDY or _Apocalypse_CD > 5)) or (_FesteringWound_COUNT >= 5 and _Apocalypse_RDY)) then
		return ids.Unholy_Ability.ScourgeStrike;
	end

	if _FesteringStrike_RDY and _Runes >= 2 and (_FesteringWound_COUNT <= 0 or (_FesteringWound_COUNT <= 4 and (_Apocalypse_RDY or _Apocalypse_CD <= 10))) then
		return ids.Unholy_Ability.FesteringStrike;
	end
	
	if _Transfusion_RDY and _RunicPower <= 50 then
		return ids.Unholy_PvPTalent.Transfusion;
	end

	if _DeathStrike_RDY and (_DarkSuccor_BUFF or _Transfusion_BUFF) then
		return ids.Unholy_Ability.DeathStrike;
	end

	if _DeathCoil_RDY and not (tChosen[ids.Unholy_Talent.SummonGargoyle] and (_SummonGargoyle_RDY or _SummonGargoyle_CD <= 10)) and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee == 1) or ConRO_SingleButton:IsVisible()) then
		return ids.Unholy_Ability.DeathCoil;
	end
		
return nil;
end

function ConRO.DeathKnight.UnholyDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Runes							 											= dkrunes();
	local _RunicPower 																	= UnitPower('player', Enum.PowerType.RunicPower);
	local _RunicPower_Max																= UnitPowerMax('player', Enum.PowerType.RunicPower);

--Abilities	
	local _DeathStrike_RDY					 											= ConRO:AbilityReady(ids.Unholy_Ability.DeathStrike, timeShift);
		local _DarkSuccor_BUFF					 											= ConRO:Aura(ids.Unholy_Buff.DarkSuccor, timeShift);
	local _IceboundFortitude_RDY		 												= ConRO:AbilityReady(ids.Unholy_Ability.IceboundFortitude, timeShift);
	local _Lichborne_RDY																= ConRO:AbilityReady(ids.Unholy_Ability.Lichborne, timeShift);
	local _SacrificialPact_RDY															= ConRO:AbilityReady(ids.Unholy_Ability.SacrificialPact, timeShift);
	
	local _DeathPact_RDY					 											= ConRO:AbilityReady(ids.Unholy_Talent.DeathPact, timeShift);	

	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");

	local _Pet_summoned 																= ConRO:CallPet();
	local _Pet_assist 																	= ConRO:PetAssist();
	local _Pet_Percent_Health															= ConRO:PercentHealth('pet');

--Rotations	
	if _DeathPact_RDY and _Player_Percent_Health <= 50 then
		return ids.Unholy_Talent.DeathPact;
	end

	if _Lichborne_RDY and _Player_Percent_Health <= 40 then
		return ids.Unholy_Ability.Lichborne;
	end

	if _SacrificialPact_RDY and _Player_Percent_Health <= 20 and _Pet_summoned then
		return ids.Unholy_Ability.SacrificialPact;
	end
	
	if _DeathStrike_RDY and (_DarkSuccor_BUFF or _Player_Percent_Health <= 30) then
		return ids.Unholy_Ability.DeathStrike;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _IceboundFortitude_RDY then
		return ids.Unholy_Ability.IceboundFortitude;
	end
		
	return nil;
end

function dkrunes()
	local _Runes = {
		rune1 = select(3, GetRuneCooldown(1));
		rune2 = select(3, GetRuneCooldown(2));
		rune3 = select(3, GetRuneCooldown(3));
		rune4 = select(3, GetRuneCooldown(4));
		rune5 = select(3, GetRuneCooldown(5));
		rune6 = select(3, GetRuneCooldown(6));
	}
	
	local totalrunes = 0;
		for k, v in pairs(_Runes) do
			if v then
				totalrunes = totalrunes + 1;
			end
		end
	return totalrunes;
end